diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 7b1d79f9c..89fca765b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -2,134 +2,136 @@ package net.minecraft.client.render.entity;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.Global;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.CompareFunc;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.AgedMob;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Math;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
 import org.slf4j.Logger;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T>{
+public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
     public static final float ENTITY_RENDER_SCALE = 16f;
     private static final Logger LOGGER = LogUtils.getLogger();
     private final @NotNull List<@Nullable StaticEntityModel> setupModels = new ArrayList<>();
+
     public MobRenderer(final float shadowSize) {
         super(shadowSize);
     }
+
     @Override
-    public void render(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+    public void render(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
         loadEntityTexture(entity);
 //        bindTexture("/assets/minecraft/textures/entity/creeper/debug.png");
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glDisable(GL11.GL_CULL_FACE);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.disableState(State.CULL_FACE);
 
-        GL11.glPushMatrix();
+        GLRenderer.pushFrame();
         preRenderTransform(entity, x, y, z, yaw, partialTick);
 
-        float brightness = entity.getBrightness(partialTick);
-        if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) brightness = 1.0f;
-
         this.setupModels.clear();
         final int maxRenderLayer = maxRenderLayer(entity);
-        for(int layer = 0; layer <= maxRenderLayer; layer++) {
+        for (int layer = 0; layer <= maxRenderLayer; layer++) {
             try {
-                final StaticEntityModel model = getAndSetupModelForLayer(entity, brightness, partialTick, layer);
+                GLRenderer.pushFrame();
+                final StaticEntityModel model = getAndSetupModelForLayer(entity, 1f, partialTick, layer);
                 this.setupModels.add(model);
                 if (model != null) {
-                    model.render(tessellator);
+                    model.render();
                 }
+                GLRenderer.popFrame();
             } catch (final Exception e) {
                 LOGGER.error("Error setting up model on layer '{}' in renderer '{}'", layer, getClass().getSimpleName(), e);
             }
         }
         renderAdditional(tessellator, entity, partialTick);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
-        final int argb = getOverlayColor(entity, brightness, partialTick);
+        final int argb = getOverlayColor(entity, 1f, partialTick);
         final boolean hasOverlayAlpha = Color.alphaFromInt(argb) > 0;
-        if(hasOverlayAlpha || entity.hurtTime > 0 || entity.deathTime > 0) {
-            GL11.glDisable(GL11.GL_TEXTURE_2D);
-            GL11.glDisable(GL11.GL_ALPHA_TEST);
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            GL11.glDepthFunc(GL11.GL_EQUAL);
-            if(entity.hurtTime > 0 || entity.deathTime > 0) {
-                for(int layer = 0; layer <= maxRenderLayer; layer++) {
+        if (hasOverlayAlpha || entity.hurtTime > 0 || entity.deathTime > 0) {
+            GLRenderer.pushFrame();
+            GLRenderer.setShader(Shaders.COLOR_WORLD);
+//            GL11.glDisable(GL11.GL_ALPHA_TEST);
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            GLRenderer.setDepthFunc(CompareFunc.EQUAL);
+            if (entity.hurtTime > 0 || entity.deathTime > 0) {
+                for (int layer = 0; layer <= maxRenderLayer; layer++) {
                     final StaticEntityModel model = this.setupModels.get(layer);
                     if (model != null) {
-                        GL11.glColor4f(brightness, 0.0F, 0.0F, 0.4F);
-                        model.render(tessellator);
+                        GLRenderer.setColor4f(1f, 0.0F, 0.0F, 0.4F);
+                        model.render();
                     }
                 }
 
             }
-            if(hasOverlayAlpha) {
-                final float r = Color.redFromInt(argb)/255f;
-                final float g = Color.greenFromInt(argb)/255f;
-                final float b = Color.blueFromInt(argb)/255f;
-                final float a = Color.alphaFromInt(argb)/255f;
-                for(int layer = 0; layer < maxRenderLayer; layer++) {
+            if (hasOverlayAlpha) {
+                final float r = Color.redFromInt(argb) / 255f;
+                final float g = Color.greenFromInt(argb) / 255f;
+                final float b = Color.blueFromInt(argb) / 255f;
+                final float a = Color.alphaFromInt(argb) / 255f;
+                for (int layer = 0; layer < maxRenderLayer; layer++) {
                     final StaticEntityModel model = this.setupModels.get(layer);
                     if (model != null) {
-                        GL11.glColor4f(r, g, b, a);
-                        model.render(tessellator);
+                        GLRenderer.setColor4f(r, g, b, a);
+                        model.render();
                     }
                 }
             }
-            GL11.glDepthFunc(GL11.GL_LEQUAL);
-            GL11.glDisable(GL11.GL_BLEND);
-            GL11.glEnable(GL11.GL_ALPHA_TEST);
-            GL11.glEnable(GL11.GL_TEXTURE_2D);
+            GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL);
+            GLRenderer.disableState(State.BLEND);
+//            GL11.glEnable(GL11.GL_ALPHA_TEST);
+            GLRenderer.popFrame();
         }
 
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
 
-        GL11.glEnable(GL11.GL_CULL_FACE);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.enableState(State.CULL_FACE);
+        GLRenderer.disableState(State.BLEND);
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         renderSpecials(tessellator, entity, x, y, z);
     }
 
     protected void preRenderTransform(final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        GL11.glTranslated(x, y, z);
-        GL11.glRotatef(-getBodyYaw(entity, partialTick) * MathHelper.RAD_TO_DEG, 0, 1, 0);
-        GL11.glScalef(1/ENTITY_RENDER_SCALE, 1/ENTITY_RENDER_SCALE, -1/ENTITY_RENDER_SCALE);
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+        GLRenderer.modelM4f().rotateY(-getBodyYaw(entity, partialTick));
+        GLRenderer.modelM4f().scale(1 / ENTITY_RENDER_SCALE, 1 / ENTITY_RENDER_SCALE, -1 / ENTITY_RENDER_SCALE);
 
-        if(entity.deathTime > 0) {
+        if (entity.deathTime > 0) {
             float rotationProgress = (((entity.deathTime + partialTick) - 1.0F) / 20F) * 1.6F;
             rotationProgress = MathHelper.sqrt_float(rotationProgress);
-            if(rotationProgress > 1.0F) {
+            if (rotationProgress > 1.0F) {
                 rotationProgress = 1.0F;
             }
-            GL11.glRotatef(rotationProgress * getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
+            GLRenderer.modelM4f().rotateZ(Math.toRadians(rotationProgress * getMaxDeathRotation(entity)));
         }
 
-        if (entity instanceof AgedMob) {
-            final AgedMob agedMob = (AgedMob) entity;
+        if (entity instanceof AgedMob agedMob) {
             final float ageScale = agedMob.getMobAge().getAgeScale();
-            GL11.glScalef(ageScale, ageScale, ageScale);
+            GLRenderer.modelM4f().scale(ageScale, ageScale, ageScale);
         }
     }
 
     @Override
     public float getShadowSize(final @NotNull T entity) {
         final float baseSize = super.getShadowSize(entity);
-        if (entity instanceof AgedMob) {
-            final AgedMob agedMob = (AgedMob) entity;
+        if (entity instanceof AgedMob agedMob) {
             final float ageScale = agedMob.getMobAge().getAgeScale();
             return baseSize * ageScale;
         }
@@ -143,7 +145,7 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T>{
 
     protected float getLimbYaw(final @NotNull T entity, final float partialTick) {
         float limbYaw = MathHelper.lerp(entity.walkAnimSpeedO, entity.walkAnimSpeed, partialTick);
-        if(limbYaw > 1.0F) {
+        if (limbYaw > 1.0F) {
             limbYaw = 1.0F;
         }
         return limbYaw;
@@ -165,64 +167,60 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T>{
         return MathHelper.lerp(entity.xRotO, entity.xRot, partialTick) * MathHelper.DEG_TO_RAD;
     }
 
-    protected void renderSpecials(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z)
-    {
-        if(Minecraft.getMinecraft().canRenderEntityLabel()) {
+    protected void renderSpecials(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z) {
+        if (Minecraft.getMinecraft().canRenderEntityLabel()) {
             renderLivingLabel(tessellator, entity, Integer.toString(entity.id), x, y, z, 64, false);
-        }
-        else if (!entity.nickname.isEmpty()) {
+        } else if (!entity.nickname.isEmpty()) {
             renderLivingLabel(tessellator, entity, entity.getDisplayName(), x, y, z, 64, true);
         }
     }
 
-    protected void renderLivingLabel(final @NotNull Tessellator t, final @NotNull T entity, final @NotNull CharSequence text, final double x, final double y, final double z, final int maxDistance, final boolean depthTest)
-    {
+    protected void renderLivingLabel(final @NotNull TessellatorGeneral t, final @NotNull T entity, final @NotNull CharSequence text, final double x, final double y, final double z, final int maxDistance, final boolean depthTest) {
         final float cameraDistance = (float) this.renderDispatcher.camera.distanceTo(entity);
-        if (cameraDistance > maxDistance)
-        {
+        if (cameraDistance > maxDistance) {
             return;
         }
         final FontRenderer sr = getFont();
-        final float scale = 1.6f/60f;
-
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float) x, (float) y + entity.getHeadHeight() + 0.8f, (float) z);
-        GL11.glNormal3f(0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(-this.renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(this.renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
-        GL11.glScalef(-scale, -scale, scale);
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glDepthMask(false);
-        if (!depthTest) GL11.glDisable(GL11.GL_DEPTH_TEST);
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
-
+        final float scale = 1.6f / 60f;
+
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y + entity.getHeadHeight() + 0.8f, (float) z);
+//        GL11.glNormal3f(0.0F, 1.0F, 0.0F);
+        GLRenderer.modelM4f().rotateY(Math.toRadians(-this.renderDispatcher.viewLerpYaw));
+        GLRenderer.modelM4f().rotateX(Math.toRadians(this.renderDispatcher.viewLerpPitch));
+        GLRenderer.modelM4f().scale(-scale, -scale, scale);
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.setDepthMask(false);
+        if (!depthTest) GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
         t.startDrawingQuads();
         final int halfTextWidth = sr.stringWidth(text) / 2;
-        t.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
+        t.setColor4f(0.0F, 0.0F, 0.0F, 0.25F);
         t.addVertex(-halfTextWidth - 1, -1, 0.0D);
-        t.addVertex(-halfTextWidth - 1,  8, 0.0D);
-        t.addVertex( halfTextWidth,      8, 0.0D);
-        t.addVertex( halfTextWidth,     -1, 0.0D);
+        t.addVertex(-halfTextWidth - 1, 8, 0.0D);
+        t.addVertex(halfTextWidth, 8, 0.0D);
+        t.addVertex(halfTextWidth, -1, 0.0D);
         t.draw();
+        GLRenderer.popFrame();
 
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
-        sr.render(t, text, -halfTextWidth, 0).setColor(0x20ffffff).call();
-        if (!depthTest) GL11.glEnable(GL11.GL_DEPTH_TEST);
-        GL11.glDepthMask(true);
-        sr.render(t, text, -halfTextWidth, 0).setColor(0xFFFFFF).call();
-        GL11.glEnable(GL11.GL_LIGHTING);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glPopMatrix();
+        sr.render(text, -halfTextWidth, 0).setColor(0x20ffffff).call();
+        if (!depthTest) GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.setDepthMask(true);
+        sr.render(text, -halfTextWidth, 0).setColor(0xFFFFFF).call();
+        GLRenderer.globalSetLightEnabled(true);
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.popFrame();
     }
 
     protected int getOverlayColor(final @NotNull T entity, final float brightness, final float partialTick) {
         return 0;
     }
 
-    protected float getMaxDeathRotation(final @NotNull T entity)
-    {
+    protected float getMaxDeathRotation(final @NotNull T entity) {
         return 90F;
     }
 
@@ -232,16 +230,13 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T>{
 
     protected abstract @Nullable StaticEntityModel getAndSetupModelForLayer(final @NotNull T entity, float brightness, final float partialTick, final int layer);
 
-    protected void renderAdditional(@NotNull final Tessellator tessellator, final @NotNull T entity, final float partialTick)
-    {
+    protected void renderAdditional(@NotNull final TessellatorGeneral tessellator, final @NotNull T entity, final float partialTick) {
     }
 
-    public void loadEntityTexture(final @NotNull T entity)
-    {
+    public void loadEntityTexture(final @NotNull T entity) {
         if (!Minecraft.getMinecraft().gameSettings.mobVariants.value) {
             bindTexture(entity.getDefaultEntityTexture());
-        }
-        else {
+        } else {
             bindTexture(entity.getEntityTexture());
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
index 885cf0526..1a1f57bca 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
@@ -2,14 +2,14 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
@@ -24,7 +24,7 @@ public abstract class MobRendererBiped<T extends Mob> extends MobRenderer<T> {
 
     @Override
     protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final T entity, final float brightness, final float partialTick, final int layer) {
-       return setupAnimations(entity, getActiveModel(entity), partialTick, layer);
+        return setupAnimations(entity, getActiveModel(entity), partialTick, layer);
     }
 
     protected @Nullable StaticEntityModel setupAnimations(@NotNull final T entity, @Nullable final StaticEntityModel model, final float partialTick, final int layer) {
@@ -59,8 +59,7 @@ public abstract class MobRendererBiped<T extends Mob> extends MobRenderer<T> {
         }
         rightLeg.rotX = Math.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
         leftLeg.rotX = Math.cos(limbSwing * 0.6662F + Math.PI) * 1.4F * limbYaw;
-        if(entity.vehicle != null)
-        {
+        if (entity.vehicle != null) {
             rightArm.rotX += -36 * MathHelper.DEG_TO_RAD;
             leftArm.rotX += -36 * MathHelper.DEG_TO_RAD;
             rightLeg.rotX = -72 * MathHelper.DEG_TO_RAD;
@@ -83,8 +82,7 @@ public abstract class MobRendererBiped<T extends Mob> extends MobRenderer<T> {
             final double rotX = Math.sin(Math.sqrt(swingProgress) * Math.PI * -2.0F) * 0.4F;
             rightArm.rotX += rotX;
             leftArm.rotX += rotX;
-        }
-        else if (entity instanceof IItemHolding && ((IItemHolding) entity).isLeftHanded()) {
+        } else if (entity instanceof IItemHolding && ((IItemHolding) entity).isLeftHanded()) {
             torso.rotY = Math.sin(Math.sqrt(swingProgress) * Math.PI * -2.0F) * 0.2F;
 
             float f6 = 1.0F - swingProgress;
@@ -112,8 +110,7 @@ public abstract class MobRendererBiped<T extends Mob> extends MobRenderer<T> {
             rightArm.rotZ = Math.sin(swingProgress * Math.PI) * -0.4F;
         }
 
-        if(entity.isSneaking())
-        {
+        if (entity.isSneaking()) {
             waist.posY -= 2;
             leftLeg.posZ += 5;
             rightLeg.posZ += 5;
@@ -138,37 +135,38 @@ public abstract class MobRendererBiped<T extends Mob> extends MobRenderer<T> {
     }
 
     @Override
-    protected void renderAdditional(@NotNull final Tessellator tessellator, final @NotNull T entity, final float partialTick) {
-        if (entity instanceof IItemHolding) {
-            final IItemHolding itemHolder = (IItemHolding) entity;
+    protected void renderAdditional(@NotNull final TessellatorGeneral tessellator, final @NotNull T entity, final float partialTick) {
+        if (entity instanceof IItemHolding itemHolder) {
             final ItemStack itemstack = itemHolder.getHeldItem();
 
             final StaticEntityModel model = getActiveModel(entity);
 
-            if(itemstack != null) {
-                GL11.glPushMatrix();
-                if (((IItemHolding) entity).isLeftHanded()) {
+            if (itemstack != null) {
+                GLRenderer.pushFrame();
+                if (itemHolder.isLeftHanded()) {
                     if (model != null) model.translateToBone("leftItem");
-                    GL11.glScalef(-1, 1, -1);
-                    GL11.glScalef(MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
+                    GLRenderer.modelM4f().scale(-1, 1, -1);
+                    GLRenderer.modelM4f().scale(MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
                     ItemModelDispatcher.getInstance().getDispatch(itemstack)
-                        .render(tessellator, entity, itemstack, DisplayPos.THIRD_PERSON_LEFT_HAND, true, 1, LightmapHelper.isLightmapEnabled() ? 1f : entity.getBrightness(partialTick), 1f, partialTick, true);
+                        .render(tessellator, entity, itemstack, DisplayPos.THIRD_PERSON_LEFT_HAND, true, 1,
+                            LightmapHelper.getLightmapCoord(GLRenderer.getLightmapSky(), GLRenderer.getLightmapBlock()), partialTick, true);
                 } else {
 
                     if (model != null) model.translateToBone("rightItem");
-                    GL11.glScalef(-1, 1, 1);
-                    GL11.glScalef(MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
+                    GLRenderer.modelM4f().scale(-1, 1, 1);
+                    GLRenderer.modelM4f().scale(MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
                     ItemModelDispatcher.getInstance().getDispatch(itemstack)
-                        .render(tessellator, entity, itemstack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1, LightmapHelper.isLightmapEnabled() ? 1f : entity.getBrightness(partialTick), 1f, partialTick, false);
+                        .render(tessellator, entity, itemstack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1,
+                            LightmapHelper.getLightmapCoord(GLRenderer.getLightmapSky(), GLRenderer.getLightmapBlock()), partialTick, false);
                 }
-                GL11.glPopMatrix();
+                GLRenderer.popFrame();
             }
         }
     }
 
     @Override
-    public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        if (entity.isSneaking()) GL11.glTranslatef(0, 2/16f, 4/16f);
+    public void renderPreview(@NotNull final TessellatorGeneral tessellator, @NotNull final T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        if (entity.isSneaking()) GLRenderer.modelM4f().translate(0, 2 / 16f, 4 / 16f);
         super.renderPreview(tessellator, entity, x, y, z, yaw, partialTick);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
index 72bc573ce..7dabe22d0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
@@ -2,7 +2,9 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.IArmorWearing;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.HumanArmorShape;
@@ -14,11 +16,10 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public abstract class MobRendererBipedArmored<T extends Mob & IArmorWearing<HumanArmorShape>> extends MobRendererBiped<T>{
+public abstract class MobRendererBipedArmored<T extends Mob & IArmorWearing<HumanArmorShape>> extends MobRendererBiped<T> {
     public MobRendererBipedArmored(final float shadowSize) {
         super(shadowSize);
     }
@@ -36,8 +37,7 @@ public abstract class MobRendererBipedArmored<T extends Mob & IArmorWearing<Huma
             bindTexture("/assets/minecraft/textures/armor/quiver_golden.png");
         } else if (item == Items.ARMOR_BOOTS_ICESKATES) {
             bindTexture("/assets/minecraft/textures/armor/skates.png");
-        } else if (item instanceof IArmorItem) {
-            final IArmorItem armorItem = (IArmorItem) item;
+        } else if (item instanceof IArmorItem<?> armorItem) {
             if (armorItem.getArmorMaterial() == null) return null;
             bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace(), armorItem.getArmorMaterial().identifier.value(), (layer != 3 ? 1 : 2)));
         } else {
@@ -94,25 +94,26 @@ public abstract class MobRendererBipedArmored<T extends Mob & IArmorWearing<Huma
         return model1;
     }
 
-    protected void renderAdditional(@NotNull final Tessellator tessellator, final @NotNull T entity, final float partialTick) {
+    protected void renderAdditional(@NotNull final TessellatorGeneral tessellator, final @NotNull T entity, final float partialTick) {
         final @Nullable ItemStack stack = entity.getItemInArmorSlot(HumanArmorShape.HEAD);
 
         final StaticEntityModel model = getActiveModel(entity);
 
-        if(stack != null) {
-            GL11.glPushMatrix();
+        if (stack != null) {
+            GLRenderer.pushFrame();
             if (model != null) model.translateToBone("head");
             if (!(stack.getItem() instanceof IArmorItem)) {
-                GL11.glPushMatrix();
-                GL11.glEnable(GL11.GL_CULL_FACE);
-                GL11.glScalef(-16, 16, 16);
-                GL11.glScalef(0.6f, 0.6f, 0.6f);
-                GL11.glTranslatef(0, 7/16f, 0);
-                ItemModelDispatcher.getInstance().getDispatch(stack).render(Tessellator.instance, null, stack, DisplayPos.HEAD, true, 1, LightmapHelper.isLightmapEnabled() ? 1f : entity.getBrightness(partialTick), 1f, partialTick, true);
-                GL11.glDisable(GL11.GL_CULL_FACE);
-                GL11.glPopMatrix();
+                GLRenderer.pushFrame();
+                GLRenderer.enableState(State.CULL_FACE);
+                GLRenderer.modelM4f().scale(-16, 16, 16);
+                GLRenderer.modelM4f().scale(0.6f, 0.6f, 0.6f);
+                GLRenderer.modelM4f().translate(0, 7 / 16f, 0);
+                ItemModelDispatcher.getInstance().getDispatch(stack).render(GLRenderer.getTessellator(), null, stack, DisplayPos.HEAD, true, 1,
+                    LightmapHelper.getLightmapCoord(GLRenderer.getLightmapSky(), GLRenderer.getLightmapBlock()), partialTick, true);
+                GLRenderer.disableState(State.CULL_FACE);
+                GLRenderer.popFrame();
             }
-            GL11.glPopMatrix();
+            GLRenderer.popFrame();
         }
 
         super.renderAdditional(tessellator, entity, partialTick);
